using System;
using System.Windows.Forms;
using System.Timers;

namespace Proyecto
{
    /*
     * Clase Temporizador: cierra un formulario automticamente si transcurren "intervalo"
     *  milisegundos desde su activacin sin llamar al mtodo reiniciar(). Para activarlo
     *  llamar al mtodo activar(). Es esttica, ya que slo habr un temporizador.
     * Autor: Juan lvaro Muoz Naranjo
     * Fecha: Junio de 2007
     */
    class Temporizador
    {
        private System.Timers.Timer timer;
        private double intervalo;
        private FormPedirContrasea formulario;

        internal void inicializar(double intv, FormPedirContrasea form)
        {
            timer = new System.Timers.Timer();
            intervalo = intv;
            timer.Interval = intervalo;
            timer.Elapsed += new ElapsedEventHandler(apagar);

            formulario = form;
            GC.KeepAlive(timer); //no s si es necesario, en msdn hay un ejemplo de Timer donde se hace
        }

        internal double Intervalo
        {
            get
            {
                return intervalo;
            }
            set
            {
                intervalo = value;
            }
        }

        internal void activar()
        {
            if (timer == null)
                throw new NullReferenceException();
            timer.Enabled = true;
        }

        internal void desactivar()
        {
            if (timer == null)
                throw new NullReferenceException();
            timer.Enabled = false;
        }

        internal void reiniciar()
        {
            if (timer == null || intervalo <= 0)
                throw new NullReferenceException();
            timer.Interval = intervalo; //al modificar la propiedad Interval se reinicia el contador
        }

        //el parmetro intv no modifica el valor del campo intervalo
        internal void reiniciar(double intv)
        {
            if (timer == null)
                throw new NullReferenceException();
            timer.Interval = intv; //al modificar la propiedad Interval se reinicia el contador
        }
       
        private void apagar(object source, ElapsedEventArgs e)
        {
            formulario.IconoBandeja.ShowBalloonTip(500,"","Cerrando la aplicacin...",ToolTipIcon.None);
            formulario.Close();
        }
    }
}